var files; // FileList object
var fileContent;
var netfileMethod;

window.addEventListener("load", function(e) {
	document.querySelector('#files').addEventListener("change", function(evt) {
	  handleFileSelect(evt);
	});
})
function handleFileSelect(evt) {
	fileContent = null;
	files = evt.target.files;

	// files is a FileList of File objects. List some properties.

	var output = [];
	for (var i = 0, f; f = files[i]; i++) {
	output.push('<li><strong>', escape(f.name), '</strong> (', f.type || 'n/a', ') - ',
                  f.size, ' bytes, last modified: ',
                  f.lastModifiedDate ? f.lastModifiedDate.toLocaleDateString() : 'n/a',
                  '</li>');
	}
	document.getElementById('list').innerHTML = '<ul>' + output.join('') + '</ul>';

	if (files.length >= 1) {
		var reader = new FileReader();
		reader.onload = function(e) {
			fileContent=reader.result;
			
			netfileMethod = 0;
			var xmlDoc2 = files[0];
	//		console.log(fileContent.substring(1, 5));
			if (fileContent.substring(0, 5) == "<?xml") {
				if (window.DOMParser) {
					var parser = new DOMParser();
					xmlDoc2 = parser.parseFromString(fileContent,"text/xml");
				}
				else {
					// Internet Explorer 
					xmlDoc2 = new ActiveXObject("Microsoft.XMLDOM");
					xmlDoc2.async = false;
					xmlDoc2.loadXML(fileContent); 
				}
				if (xmlDoc2.getElementsByTagName("T1Return").length != 0) {
					netfileMethod = 2;
				}
				else if (xmlDoc2.getElementsByTagName("ForeignIncomeVerificationStatement").length != 0) {
					netfileMethod = 12;
				}		
			}
		}
		reader.readAsText(files[0]);
		document.getElementById('termConditionBtn').style.display="block";

	}
	else {
		document.getElementById('termConditionBtn').style.display="none";
	}
	document.getElementById('uploadBtn').style.display="none";
	document.getElementById('chkboxTerm').checked=false;
	document.getElementById('firstTime').checked=false;
    document.querySelector('#firstTimeInfo').style.display = "none";
    document.querySelector('#firstName').value = "";
    document.querySelector('#secondName').value = "";
    document.querySelector('#familyName').value = "";   	
 	document.getElementById('fiveDayPayment').checked=false;
	termlinkClicked = false;
}
