var SecondsSince1970;
var UTCString;
var SIN;
var tokenFromCRA = "";
var TDDResend;

window.addEventListener("load", function(e) {
    document.querySelector('#CRATDDOK').addEventListener("click", function(evt) {
      enterSIN();
    });
    document.querySelector('#SINOK').addEventListener("click", function(evt) {
      showCRATDD();
    });
    document.querySelector('#CRATDDCancel').addEventListener("click", function(evt) {
      showSelectFunction();
    });
    document.querySelector('#CRATDDBack').addEventListener("click", function(evt) {
      showSelectFunction1();
    });
    document.querySelector('#SINCancel').addEventListener("click", function(evt) {
      showSelectFunction2();
    });
})
function enterSIN()
{
    document.getElementById('tddMsg15').style.display="none";
    document.getElementById('tddMsg16').style.display="none";
    document.getElementById('tddButtons').style.display="none";
    document.getElementById('enterSIN').style.display="block";
}
function showCRATDD()
{
    SIN = document.getElementById('SIN').value
    if (SIN.length == 0) {
        showDialogBox("Please enter SIN.");
	return;
    }
    if (SIN.length != 9) {
        showDialogBox("Length of SIN should be 9.");
        return;
    }
    if (isNaN(Number(SIN))) {
        showDialogBox("SIN should be a number.");
        return
    }

    document.getElementById('enterSIN').style.display="none";
    connect2NTP(1);
}
function connect2NTP(mode) {
    chrome.sockets.tcp.create({},
            function (createInfo) {
                console.log(createInfo.socketId);
                   chrome.sockets.tcp.connect(createInfo.socketId,
                        "time4.nrc.ca", 37,
                        function (result) {
                            if (chrome.runtime.lastError) {
                                    console.log(chrome.runtime.lastError.message);
                        document.getElementById('NTPAccess').style.display="block";
                        document.getElementById('NTPError').innerHTML = "Failed to connect to NTP server for accurate time: " + chrome.runtime.lastError.message;
                        return;
                    }
                            else {
                                    console.log(result);
                                    chrome.sockets.tcp.onReceive.addListener(listener =
                                           function (info) {
                                                if (info.data)
                                                       console.log(ab2seconds(info.data));
                                               var d = new Date();
                                               SecondsSince1970 = ab2seconds(info.data) - 2208988800;
                                               d.setTime(SecondsSince1970 * 1000);
                                               console.log(d.toLocaleString());
                                               console.log(d.toUTCString());
                                               UTCString = d.getUTCFullYear() + "-"
                                               UTCString += (((d.getUTCMonth() + 1) < 10) ? ("0" + (d.getUTCMonth() + 1)) : (d.getUTCMonth() + 1)) + "-";
                                               UTCString += ((d.getUTCDate() < 10) ? ("0" + d.getUTCDate()) : d.getUTCDate()) + "T";
                                               UTCString += ((d.getUTCHours() < 10) ? ("0" + d.getUTCHours()) : d.getUTCHours()) + ":";
                                               UTCString += ((d.getUTCMinutes() < 10) ? ("0" + d.getUTCMinutes()) : d.getUTCMinutes()) + ":";
                                               UTCString += ((d.getUTCSeconds() < 10) ? ("0" + d.getUTCSeconds()) : d.getUTCSeconds()) + ".0000000Z";
                                               console.log(UTCString);
                                               if (mode == 1) {
                                                   var xmlDoc1 = loadXMLDocStageTDD(taxYear + "/stageTDD.xml");
                                               }
                                               else if (mode == 2) {
                                                   var xmlDoc1 = loadXMLDocGetTDD(taxYear + "/getTDD.xml");
                                               }
                                               chrome.sockets.tcp.disconnect(createInfo.socketId);
                                               chrome.sockets.tcp.close(createInfo.socketId);
                                               chrome.sockets.tcp.onReceive.removeListener(listener);
                                               return;
                                           }
                                    );
                               }
                        }
                );
            }
    );
}
function showSelectFunction()
{
    document.getElementById('tddMsg15').style.display="none";
    document.getElementById('tddMsg16').style.display="none";
    document.getElementById('tddButtons').style.display="none";
    document.getElementById('selectFunction').style.display="block";
}
function showSelectFunction1()
{
    document.getElementById('NTPAccess').style.display="none";
    document.getElementById('selectFunction').style.display="block";
}
function showSelectFunction2()
{
    document.getElementById('enterSIN').style.display="none";
    document.getElementById('selectFunction').style.display="block";
}
function ab2seconds(buf) {
//  return String.fromCharCode.apply(null, new Uint16Array(buf));
    var bufView = new Uint8Array(buf);
    var value = 0;
    value = bufView[0] * 256;
    value = (value + bufView[1]) * 256;
    value = (value + bufView[2]) * 256;
    value = value + bufView[3];
    return value;
}
function showCRATDD1() {
     document.getElementById('lblMsg').innerHTML="No connection";
    document.getElementById('cratdd').style.display="block";
}
function showCRAWeb() {
    var CRAWebAppURL;
    if (CRAEPS) {
        CRAWebAppURL = "https://apps-ct.cra-arc.gc.ca/ebci/awsc/tdd/certtest/auth/start";
    }
    else {
        CRAWebAppURL = "https://ams-sga.cra-arc.gc.ca/gol-ged/awsc/tdd/auth/start";
    }
    var tmpUrl = CRAWebAppURL;
    tmpUrl = CRAWebAppURL
    if (taxYear == 2015) {
        tmpUrl += "?spID=" + "102N";
    }
    else {
        tmpUrl += "?spID=" + "104N";
    }
    tmpUrl += "&timestamp=" + SecondsSince1970;
    tmpUrl += "&auth=" + encodeURIComponent("/gol-ged/awsc/tdd/ws");
    var baseStr;
    if (taxYear == 2015) {
        baseStr = "102N";
    }
    else {
        baseStr = "104N";
    }
    baseStr += encodeURIComponent(CRAWebAppURL.substring(8));
    baseStr += SecondsSince1970; 
    baseStr += encodeURIComponent("/gol-ged/awsc/tdd/ws");
    baseStr += "en";
    baseStr += encodeURIComponent(tokenFromCRA);
    if (taxYear != 2015) {
        baseStr += taxYear;
    }
//    console.log(baseStr);
    var signedKey = "";
    var shaObj = new jsSHA("SHA-256","TEXT");
    shaObj.setHMACKey(CRATDDSecretKey, "TEXT");
    shaObj.update(baseStr);
    signedKey = shaObj.getHMAC("B64");
//    console.log(signedKey);
    tmpUrl += "&key=" + encodeURIComponent(signedKey);
    tmpUrl += "&t=" + encodeURIComponent(tokenFromCRA);
    tmpUrl += "&lang=en";
    if (taxYear != 2015) {
        tmpUrl += "&swtaxyear=" + taxYear;
    }
    console.log(tmpUrl);
//    window.open(tmpUrl);
    openInChrome(tmpUrl); 
}
// Open new window in Chrome instead of default browser.
// app window
function openInChrome(url) {
  chrome.runtime.sendMessage({action: "openURL", url: url});
}
